import { LitElement, PropertyValueMap } from 'lit';
import { GaugeChartConfiguration } from './definition-schema.js';
export declare class WidgetGauge extends LitElement {
    inputData?: GaugeChartConfiguration;
    private dataSets;
    private canvasList;
    private resizeObserver;
    boxes?: HTMLDivElement[];
    origWidth: number;
    origHeight: number;
    template: any;
    modifier: number;
    version: string;
    gaugeContainer: HTMLDivElement | null | undefined;
    constructor();
    disconnectedCallback(): void;
    update(changedProperties: Map<string, any>): void;
    protected firstUpdated(_changedProperties: PropertyValueMap<any> | Map<PropertyKey, unknown>): void;
    sizingSetup(): void;
    adjustSizes(): void;
    transformData(): Promise<void>;
    applyData(): void;
    setupCharts(): void;
    static styles: import("lit").CSSResult;
    render(): import("lit-html").TemplateResult<1>;
}
