/* @license Copyright (c) 2023 Record Evolution GmbH. All rights reserved.*/
/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise, SuppressedError, Symbol, Iterator */

function __decorate(decorators, target, key, desc) {
  var c = arguments.length,
    r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
    d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
}
typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
  var e = new Error(message);
  return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

/**
 * @license
 * Copyright 2019 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const t = globalThis,
  e$1 = t.ShadowRoot && (void 0 === t.ShadyCSS || t.ShadyCSS.nativeShadow) && "adoptedStyleSheets" in Document.prototype && "replace" in CSSStyleSheet.prototype,
  s = Symbol(),
  o$2 = new WeakMap();
let n$3 = class n {
  constructor(t, e, o) {
    if (this._$cssResult$ = !0, o !== s) throw Error("CSSResult is not constructable. Use `unsafeCSS` or `css` instead.");
    this.cssText = t, this.t = e;
  }
  get styleSheet() {
    let t = this.o;
    const s = this.t;
    if (e$1 && void 0 === t) {
      const e = void 0 !== s && 1 === s.length;
      e && (t = o$2.get(s)), void 0 === t && ((this.o = t = new CSSStyleSheet()).replaceSync(this.cssText), e && o$2.set(s, t));
    }
    return t;
  }
  toString() {
    return this.cssText;
  }
};
const r$3 = t => new n$3("string" == typeof t ? t : t + "", void 0, s),
  i$1 = (t, ...e) => {
    const o = 1 === t.length ? t[0] : e.reduce((e, s, o) => e + (t => {
      if (!0 === t._$cssResult$) return t.cssText;
      if ("number" == typeof t) return t;
      throw Error("Value passed to 'css' function must be a 'css' function result: " + t + ". Use 'unsafeCSS' to pass non-literal values, but take care to ensure page security.");
    })(s) + t[o + 1], t[0]);
    return new n$3(o, t, s);
  },
  S$1 = (s, o) => {
    if (e$1) s.adoptedStyleSheets = o.map(t => t instanceof CSSStyleSheet ? t : t.styleSheet);else for (const e of o) {
      const o = document.createElement("style"),
        n = t.litNonce;
      void 0 !== n && o.setAttribute("nonce", n), o.textContent = e.cssText, s.appendChild(o);
    }
  },
  c$2 = e$1 ? t => t : t => t instanceof CSSStyleSheet ? (t => {
    let e = "";
    for (const s of t.cssRules) e += s.cssText;
    return r$3(e);
  })(t) : t;

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const {
    is: i,
    defineProperty: e,
    getOwnPropertyDescriptor: r$2,
    getOwnPropertyNames: h$2,
    getOwnPropertySymbols: o$1,
    getPrototypeOf: n$2
  } = Object,
  a = globalThis,
  c$1 = a.trustedTypes,
  l = c$1 ? c$1.emptyScript : "",
  p = a.reactiveElementPolyfillSupport,
  d = (t, s) => t,
  u = {
    toAttribute(t, s) {
      switch (s) {
        case Boolean:
          t = t ? l : null;
          break;
        case Object:
        case Array:
          t = null == t ? t : JSON.stringify(t);
      }
      return t;
    },
    fromAttribute(t, s) {
      let i = t;
      switch (s) {
        case Boolean:
          i = null !== t;
          break;
        case Number:
          i = null === t ? null : Number(t);
          break;
        case Object:
        case Array:
          try {
            i = JSON.parse(t);
          } catch (t) {
            i = null;
          }
      }
      return i;
    }
  },
  f$2 = (t, s) => !i(t, s),
  y = {
    attribute: !0,
    type: String,
    converter: u,
    reflect: !1,
    hasChanged: f$2
  };
Symbol.metadata ??= Symbol("metadata"), a.litPropertyMetadata ??= new WeakMap();
class b extends HTMLElement {
  static addInitializer(t) {
    this._$Ei(), (this.l ??= []).push(t);
  }
  static get observedAttributes() {
    return this.finalize(), this._$Eh && [...this._$Eh.keys()];
  }
  static createProperty(t, s = y) {
    if (s.state && (s.attribute = !1), this._$Ei(), this.elementProperties.set(t, s), !s.noAccessor) {
      const i = Symbol(),
        r = this.getPropertyDescriptor(t, i, s);
      void 0 !== r && e(this.prototype, t, r);
    }
  }
  static getPropertyDescriptor(t, s, i) {
    const {
      get: e,
      set: h
    } = r$2(this.prototype, t) ?? {
      get() {
        return this[s];
      },
      set(t) {
        this[s] = t;
      }
    };
    return {
      get() {
        return e?.call(this);
      },
      set(s) {
        const r = e?.call(this);
        h.call(this, s), this.requestUpdate(t, r, i);
      },
      configurable: !0,
      enumerable: !0
    };
  }
  static getPropertyOptions(t) {
    return this.elementProperties.get(t) ?? y;
  }
  static _$Ei() {
    if (this.hasOwnProperty(d("elementProperties"))) return;
    const t = n$2(this);
    t.finalize(), void 0 !== t.l && (this.l = [...t.l]), this.elementProperties = new Map(t.elementProperties);
  }
  static finalize() {
    if (this.hasOwnProperty(d("finalized"))) return;
    if (this.finalized = !0, this._$Ei(), this.hasOwnProperty(d("properties"))) {
      const t = this.properties,
        s = [...h$2(t), ...o$1(t)];
      for (const i of s) this.createProperty(i, t[i]);
    }
    const t = this[Symbol.metadata];
    if (null !== t) {
      const s = litPropertyMetadata.get(t);
      if (void 0 !== s) for (const [t, i] of s) this.elementProperties.set(t, i);
    }
    this._$Eh = new Map();
    for (const [t, s] of this.elementProperties) {
      const i = this._$Eu(t, s);
      void 0 !== i && this._$Eh.set(i, t);
    }
    this.elementStyles = this.finalizeStyles(this.styles);
  }
  static finalizeStyles(s) {
    const i = [];
    if (Array.isArray(s)) {
      const e = new Set(s.flat(1 / 0).reverse());
      for (const s of e) i.unshift(c$2(s));
    } else void 0 !== s && i.push(c$2(s));
    return i;
  }
  static _$Eu(t, s) {
    const i = s.attribute;
    return !1 === i ? void 0 : "string" == typeof i ? i : "string" == typeof t ? t.toLowerCase() : void 0;
  }
  constructor() {
    super(), this._$Ep = void 0, this.isUpdatePending = !1, this.hasUpdated = !1, this._$Em = null, this._$Ev();
  }
  _$Ev() {
    this._$ES = new Promise(t => this.enableUpdating = t), this._$AL = new Map(), this._$E_(), this.requestUpdate(), this.constructor.l?.forEach(t => t(this));
  }
  addController(t) {
    (this._$EO ??= new Set()).add(t), void 0 !== this.renderRoot && this.isConnected && t.hostConnected?.();
  }
  removeController(t) {
    this._$EO?.delete(t);
  }
  _$E_() {
    const t = new Map(),
      s = this.constructor.elementProperties;
    for (const i of s.keys()) this.hasOwnProperty(i) && (t.set(i, this[i]), delete this[i]);
    t.size > 0 && (this._$Ep = t);
  }
  createRenderRoot() {
    const t = this.shadowRoot ?? this.attachShadow(this.constructor.shadowRootOptions);
    return S$1(t, this.constructor.elementStyles), t;
  }
  connectedCallback() {
    this.renderRoot ??= this.createRenderRoot(), this.enableUpdating(!0), this._$EO?.forEach(t => t.hostConnected?.());
  }
  enableUpdating(t) {}
  disconnectedCallback() {
    this._$EO?.forEach(t => t.hostDisconnected?.());
  }
  attributeChangedCallback(t, s, i) {
    this._$AK(t, i);
  }
  _$EC(t, s) {
    const i = this.constructor.elementProperties.get(t),
      e = this.constructor._$Eu(t, i);
    if (void 0 !== e && !0 === i.reflect) {
      const r = (void 0 !== i.converter?.toAttribute ? i.converter : u).toAttribute(s, i.type);
      this._$Em = t, null == r ? this.removeAttribute(e) : this.setAttribute(e, r), this._$Em = null;
    }
  }
  _$AK(t, s) {
    const i = this.constructor,
      e = i._$Eh.get(t);
    if (void 0 !== e && this._$Em !== e) {
      const t = i.getPropertyOptions(e),
        r = "function" == typeof t.converter ? {
          fromAttribute: t.converter
        } : void 0 !== t.converter?.fromAttribute ? t.converter : u;
      this._$Em = e, this[e] = r.fromAttribute(s, t.type), this._$Em = null;
    }
  }
  requestUpdate(t, s, i) {
    if (void 0 !== t) {
      if (i ??= this.constructor.getPropertyOptions(t), !(i.hasChanged ?? f$2)(this[t], s)) return;
      this.P(t, s, i);
    }
    !1 === this.isUpdatePending && (this._$ES = this._$ET());
  }
  P(t, s, i) {
    this._$AL.has(t) || this._$AL.set(t, s), !0 === i.reflect && this._$Em !== t && (this._$Ej ??= new Set()).add(t);
  }
  async _$ET() {
    this.isUpdatePending = !0;
    try {
      await this._$ES;
    } catch (t) {
      Promise.reject(t);
    }
    const t = this.scheduleUpdate();
    return null != t && (await t), !this.isUpdatePending;
  }
  scheduleUpdate() {
    return this.performUpdate();
  }
  performUpdate() {
    if (!this.isUpdatePending) return;
    if (!this.hasUpdated) {
      if (this.renderRoot ??= this.createRenderRoot(), this._$Ep) {
        for (const [t, s] of this._$Ep) this[t] = s;
        this._$Ep = void 0;
      }
      const t = this.constructor.elementProperties;
      if (t.size > 0) for (const [s, i] of t) !0 !== i.wrapped || this._$AL.has(s) || void 0 === this[s] || this.P(s, this[s], i);
    }
    let t = !1;
    const s = this._$AL;
    try {
      t = this.shouldUpdate(s), t ? (this.willUpdate(s), this._$EO?.forEach(t => t.hostUpdate?.()), this.update(s)) : this._$EU();
    } catch (s) {
      throw t = !1, this._$EU(), s;
    }
    t && this._$AE(s);
  }
  willUpdate(t) {}
  _$AE(t) {
    this._$EO?.forEach(t => t.hostUpdated?.()), this.hasUpdated || (this.hasUpdated = !0, this.firstUpdated(t)), this.updated(t);
  }
  _$EU() {
    this._$AL = new Map(), this.isUpdatePending = !1;
  }
  get updateComplete() {
    return this.getUpdateComplete();
  }
  getUpdateComplete() {
    return this._$ES;
  }
  shouldUpdate(t) {
    return !0;
  }
  update(t) {
    this._$Ej &&= this._$Ej.forEach(t => this._$EC(t, this[t])), this._$EU();
  }
  updated(t) {}
  firstUpdated(t) {}
}
b.elementStyles = [], b.shadowRootOptions = {
  mode: "open"
}, b[d("elementProperties")] = new Map(), b[d("finalized")] = new Map(), p?.({
  ReactiveElement: b
}), (a.reactiveElementVersions ??= []).push("2.0.4");

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const n$1 = globalThis,
  c = n$1.trustedTypes,
  h$1 = c ? c.createPolicy("lit-html", {
    createHTML: t => t
  }) : void 0,
  f$1 = "$lit$",
  v = `lit$${Math.random().toFixed(9).slice(2)}$`,
  m = "?" + v,
  _ = `<${m}>`,
  w = document,
  lt = () => w.createComment(""),
  st = t => null === t || "object" != typeof t && "function" != typeof t,
  g = Array.isArray,
  $ = t => g(t) || "function" == typeof t?.[Symbol.iterator],
  x = "[ \t\n\f\r]",
  T = /<(?:(!--|\/[^a-zA-Z])|(\/?[a-zA-Z][^>\s]*)|(\/?$))/g,
  E = /-->/g,
  k = />/g,
  O = RegExp(`>|${x}(?:([^\\s"'>=/]+)(${x}*=${x}*(?:[^ \t\n\f\r"'\`<>=]|("|')|))|$)`, "g"),
  S = /'/g,
  j = /"/g,
  M = /^(?:script|style|textarea|title)$/i,
  P = t => (i, ...s) => ({
    _$litType$: t,
    strings: i,
    values: s
  }),
  ke = P(1),
  R = Symbol.for("lit-noChange"),
  D = Symbol.for("lit-nothing"),
  V = new WeakMap(),
  I = w.createTreeWalker(w, 129);
function N(t, i) {
  if (!g(t) || !t.hasOwnProperty("raw")) throw Error("invalid template strings array");
  return void 0 !== h$1 ? h$1.createHTML(i) : i;
}
const U = (t, i) => {
  const s = t.length - 1,
    e = [];
  let h,
    o = 2 === i ? "<svg>" : 3 === i ? "<math>" : "",
    n = T;
  for (let i = 0; i < s; i++) {
    const s = t[i];
    let r,
      l,
      c = -1,
      a = 0;
    for (; a < s.length && (n.lastIndex = a, l = n.exec(s), null !== l);) a = n.lastIndex, n === T ? "!--" === l[1] ? n = E : void 0 !== l[1] ? n = k : void 0 !== l[2] ? (M.test(l[2]) && (h = RegExp("</" + l[2], "g")), n = O) : void 0 !== l[3] && (n = O) : n === O ? ">" === l[0] ? (n = h ?? T, c = -1) : void 0 === l[1] ? c = -2 : (c = n.lastIndex - l[2].length, r = l[1], n = void 0 === l[3] ? O : '"' === l[3] ? j : S) : n === j || n === S ? n = O : n === E || n === k ? n = T : (n = O, h = void 0);
    const u = n === O && t[i + 1].startsWith("/>") ? " " : "";
    o += n === T ? s + _ : c >= 0 ? (e.push(r), s.slice(0, c) + f$1 + s.slice(c) + v + u) : s + v + (-2 === c ? i : u);
  }
  return [N(t, o + (t[s] || "<?>") + (2 === i ? "</svg>" : 3 === i ? "</math>" : "")), e];
};
class B {
  constructor({
    strings: t,
    _$litType$: i
  }, s) {
    let e;
    this.parts = [];
    let h = 0,
      o = 0;
    const n = t.length - 1,
      r = this.parts,
      [l, a] = U(t, i);
    if (this.el = B.createElement(l, s), I.currentNode = this.el.content, 2 === i || 3 === i) {
      const t = this.el.content.firstChild;
      t.replaceWith(...t.childNodes);
    }
    for (; null !== (e = I.nextNode()) && r.length < n;) {
      if (1 === e.nodeType) {
        if (e.hasAttributes()) for (const t of e.getAttributeNames()) if (t.endsWith(f$1)) {
          const i = a[o++],
            s = e.getAttribute(t).split(v),
            n = /([.?@])?(.*)/.exec(i);
          r.push({
            type: 1,
            index: h,
            name: n[2],
            strings: s,
            ctor: "." === n[1] ? Y : "?" === n[1] ? Z : "@" === n[1] ? q : G
          }), e.removeAttribute(t);
        } else t.startsWith(v) && (r.push({
          type: 6,
          index: h
        }), e.removeAttribute(t));
        if (M.test(e.tagName)) {
          const t = e.textContent.split(v),
            i = t.length - 1;
          if (i > 0) {
            e.textContent = c ? c.emptyScript : "";
            for (let s = 0; s < i; s++) e.append(t[s], lt()), I.nextNode(), r.push({
              type: 2,
              index: ++h
            });
            e.append(t[i], lt());
          }
        }
      } else if (8 === e.nodeType) if (e.data === m) r.push({
        type: 2,
        index: h
      });else {
        let t = -1;
        for (; -1 !== (t = e.data.indexOf(v, t + 1));) r.push({
          type: 7,
          index: h
        }), t += v.length - 1;
      }
      h++;
    }
  }
  static createElement(t, i) {
    const s = w.createElement("template");
    return s.innerHTML = t, s;
  }
}
function z(t, i, s = t, e) {
  if (i === R) return i;
  let h = void 0 !== e ? s.o?.[e] : s.l;
  const o = st(i) ? void 0 : i._$litDirective$;
  return h?.constructor !== o && (h?._$AO?.(!1), void 0 === o ? h = void 0 : (h = new o(t), h._$AT(t, s, e)), void 0 !== e ? (s.o ??= [])[e] = h : s.l = h), void 0 !== h && (i = z(t, h._$AS(t, i.values), h, e)), i;
}
class F {
  constructor(t, i) {
    this._$AV = [], this._$AN = void 0, this._$AD = t, this._$AM = i;
  }
  get parentNode() {
    return this._$AM.parentNode;
  }
  get _$AU() {
    return this._$AM._$AU;
  }
  u(t) {
    const {
        el: {
          content: i
        },
        parts: s
      } = this._$AD,
      e = (t?.creationScope ?? w).importNode(i, !0);
    I.currentNode = e;
    let h = I.nextNode(),
      o = 0,
      n = 0,
      r = s[0];
    for (; void 0 !== r;) {
      if (o === r.index) {
        let i;
        2 === r.type ? i = new et(h, h.nextSibling, this, t) : 1 === r.type ? i = new r.ctor(h, r.name, r.strings, this, t) : 6 === r.type && (i = new K(h, this, t)), this._$AV.push(i), r = s[++n];
      }
      o !== r?.index && (h = I.nextNode(), o++);
    }
    return I.currentNode = w, e;
  }
  p(t) {
    let i = 0;
    for (const s of this._$AV) void 0 !== s && (void 0 !== s.strings ? (s._$AI(t, s, i), i += s.strings.length - 2) : s._$AI(t[i])), i++;
  }
}
class et {
  get _$AU() {
    return this._$AM?._$AU ?? this.v;
  }
  constructor(t, i, s, e) {
    this.type = 2, this._$AH = D, this._$AN = void 0, this._$AA = t, this._$AB = i, this._$AM = s, this.options = e, this.v = e?.isConnected ?? !0;
  }
  get parentNode() {
    let t = this._$AA.parentNode;
    const i = this._$AM;
    return void 0 !== i && 11 === t?.nodeType && (t = i.parentNode), t;
  }
  get startNode() {
    return this._$AA;
  }
  get endNode() {
    return this._$AB;
  }
  _$AI(t, i = this) {
    t = z(this, t, i), st(t) ? t === D || null == t || "" === t ? (this._$AH !== D && this._$AR(), this._$AH = D) : t !== this._$AH && t !== R && this._(t) : void 0 !== t._$litType$ ? this.$(t) : void 0 !== t.nodeType ? this.T(t) : $(t) ? this.k(t) : this._(t);
  }
  O(t) {
    return this._$AA.parentNode.insertBefore(t, this._$AB);
  }
  T(t) {
    this._$AH !== t && (this._$AR(), this._$AH = this.O(t));
  }
  _(t) {
    this._$AH !== D && st(this._$AH) ? this._$AA.nextSibling.data = t : this.T(w.createTextNode(t)), this._$AH = t;
  }
  $(t) {
    const {
        values: i,
        _$litType$: s
      } = t,
      e = "number" == typeof s ? this._$AC(t) : (void 0 === s.el && (s.el = B.createElement(N(s.h, s.h[0]), this.options)), s);
    if (this._$AH?._$AD === e) this._$AH.p(i);else {
      const t = new F(e, this),
        s = t.u(this.options);
      t.p(i), this.T(s), this._$AH = t;
    }
  }
  _$AC(t) {
    let i = V.get(t.strings);
    return void 0 === i && V.set(t.strings, i = new B(t)), i;
  }
  k(t) {
    g(this._$AH) || (this._$AH = [], this._$AR());
    const i = this._$AH;
    let s,
      e = 0;
    for (const h of t) e === i.length ? i.push(s = new et(this.O(lt()), this.O(lt()), this, this.options)) : s = i[e], s._$AI(h), e++;
    e < i.length && (this._$AR(s && s._$AB.nextSibling, e), i.length = e);
  }
  _$AR(t = this._$AA.nextSibling, i) {
    for (this._$AP?.(!1, !0, i); t && t !== this._$AB;) {
      const i = t.nextSibling;
      t.remove(), t = i;
    }
  }
  setConnected(t) {
    void 0 === this._$AM && (this.v = t, this._$AP?.(t));
  }
}
class G {
  get tagName() {
    return this.element.tagName;
  }
  get _$AU() {
    return this._$AM._$AU;
  }
  constructor(t, i, s, e, h) {
    this.type = 1, this._$AH = D, this._$AN = void 0, this.element = t, this.name = i, this._$AM = e, this.options = h, s.length > 2 || "" !== s[0] || "" !== s[1] ? (this._$AH = Array(s.length - 1).fill(new String()), this.strings = s) : this._$AH = D;
  }
  _$AI(t, i = this, s, e) {
    const h = this.strings;
    let o = !1;
    if (void 0 === h) t = z(this, t, i, 0), o = !st(t) || t !== this._$AH && t !== R, o && (this._$AH = t);else {
      const e = t;
      let n, r;
      for (t = h[0], n = 0; n < h.length - 1; n++) r = z(this, e[s + n], i, n), r === R && (r = this._$AH[n]), o ||= !st(r) || r !== this._$AH[n], r === D ? t = D : t !== D && (t += (r ?? "") + h[n + 1]), this._$AH[n] = r;
    }
    o && !e && this.j(t);
  }
  j(t) {
    t === D ? this.element.removeAttribute(this.name) : this.element.setAttribute(this.name, t ?? "");
  }
}
class Y extends G {
  constructor() {
    super(...arguments), this.type = 3;
  }
  j(t) {
    this.element[this.name] = t === D ? void 0 : t;
  }
}
class Z extends G {
  constructor() {
    super(...arguments), this.type = 4;
  }
  j(t) {
    this.element.toggleAttribute(this.name, !!t && t !== D);
  }
}
class q extends G {
  constructor(t, i, s, e, h) {
    super(t, i, s, e, h), this.type = 5;
  }
  _$AI(t, i = this) {
    if ((t = z(this, t, i, 0) ?? D) === R) return;
    const s = this._$AH,
      e = t === D && s !== D || t.capture !== s.capture || t.once !== s.once || t.passive !== s.passive,
      h = t !== D && (s === D || e);
    e && this.element.removeEventListener(this.name, this, s), h && this.element.addEventListener(this.name, this, t), this._$AH = t;
  }
  handleEvent(t) {
    "function" == typeof this._$AH ? this._$AH.call(this.options?.host ?? this.element, t) : this._$AH.handleEvent(t);
  }
}
class K {
  constructor(t, i, s) {
    this.element = t, this.type = 6, this._$AN = void 0, this._$AM = i, this.options = s;
  }
  get _$AU() {
    return this._$AM._$AU;
  }
  _$AI(t) {
    z(this, t);
  }
}
const Re = n$1.litHtmlPolyfillSupport;
Re?.(B, et), (n$1.litHtmlVersions ??= []).push("3.2.0");
const Q = (t, i, s) => {
  const e = s?.renderBefore ?? i;
  let h = e._$litPart$;
  if (void 0 === h) {
    const t = s?.renderBefore ?? null;
    e._$litPart$ = h = new et(i.insertBefore(lt(), t), t, void 0, s ?? {});
  }
  return h._$AI(t), h;
};

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
class h extends b {
  constructor() {
    super(...arguments), this.renderOptions = {
      host: this
    }, this.o = void 0;
  }
  createRenderRoot() {
    const t = super.createRenderRoot();
    return this.renderOptions.renderBefore ??= t.firstChild, t;
  }
  update(t) {
    const e = this.render();
    this.hasUpdated || (this.renderOptions.isConnected = this.isConnected), super.update(t), this.o = Q(e, this.renderRoot, this.renderOptions);
  }
  connectedCallback() {
    super.connectedCallback(), this.o?.setConnected(!0);
  }
  disconnectedCallback() {
    super.disconnectedCallback(), this.o?.setConnected(!1);
  }
  render() {
    return R;
  }
}
h._$litElement$ = !0, h["finalized"] = !0, globalThis.litElementHydrateSupport?.({
  LitElement: h
});
const f = globalThis.litElementPolyfillSupport;
f?.({
  LitElement: h
});
(globalThis.litElementVersions ??= []).push("4.1.0");

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
const o = {
    attribute: !0,
    type: String,
    converter: u,
    reflect: !1,
    hasChanged: f$2
  },
  r$1 = (t = o, e, r) => {
    const {
      kind: n,
      metadata: i
    } = r;
    let s = globalThis.litPropertyMetadata.get(i);
    if (void 0 === s && globalThis.litPropertyMetadata.set(i, s = new Map()), s.set(r.name, t), "accessor" === n) {
      const {
        name: o
      } = r;
      return {
        set(r) {
          const n = e.get.call(this);
          e.set.call(this, r), this.requestUpdate(o, n, t);
        },
        init(e) {
          return void 0 !== e && this.P(o, void 0, t), e;
        }
      };
    }
    if ("setter" === n) {
      const {
        name: o
      } = r;
      return function (r) {
        const n = this[o];
        e.call(this, r), this.requestUpdate(o, n, t);
      };
    }
    throw Error("Unsupported decorator location: " + n);
  };
function n(t) {
  return (e, o) => "object" == typeof o ? r$1(t, e, o) : ((t, e, o) => {
    const r = e.hasOwnProperty(o);
    return e.constructor.createProperty(o, r ? {
      ...t,
      wrapped: !0
    } : t), r ? Object.getOwnPropertyDescriptor(e, o) : void 0;
  })(t, e, o);
}

/**
 * @license
 * Copyright 2017 Google LLC
 * SPDX-License-Identifier: BSD-3-Clause
 */
function r(r) {
  return n({
    ...r,
    state: !0,
    attribute: !1
  });
}

class WidgetGauge extends h {
    constructor() {
        super();
        this.dataSets = [];
        this.canvasList = {};
        this.origWidth = 0;
        this.origHeight = 0;
        this.modifier = 1;
        this.version = '1.6.10';
        this.resizeObserver = new ResizeObserver(this.adjustSizes.bind(this));
        this.template = {
            title: {
                text: 'Gauge',
                left: 'center',
                textStyle: {
                    fontSize: 10
                }
            },
            series: [
                {
                    type: 'gauge',
                    startAngle: 180,
                    endAngle: 0,
                    min: 33,
                    max: 99,
                    radius: '121%',
                    center: ['50%', '90%'],
                    progress: {
                        show: true,
                        clip: true,
                        width: 50,
                        roundCap: false,
                        itemStyle: {
                            color: 'auto'
                        }
                    },
                    axisLine: { show: false },
                    axisTick: { show: false },
                    splitLine: { show: false },
                    axisLabel: { show: false },
                    anchor: { show: false },
                    pointer: { show: false },
                    detail: {
                        valueAnimation: false,
                        fontSize: 25,
                        offsetCenter: [0, '-7%'],
                        color: 'inherit'
                    },
                    title: {
                        offsetCenter: [0, '-35%'],
                        fontSize: 20
                    },
                    data: [
                        {
                            value: 70
                        }
                    ]
                },
                {
                    type: 'gauge',
                    startAngle: 180,
                    endAngle: 0,
                    min: 33,
                    max: 99,
                    radius: '125%',
                    center: ['50%', '90%'],
                    axisLine: {
                        lineStyle: {
                            width: 20,
                            color: [
                                [0.2, '#67e0e3'],
                                [0.8, '#37a2da'],
                                [1, '#fd666d']
                            ]
                        }
                    },
                    axisTick: { show: false },
                    splitLine: {
                        length: 15,
                        distance: -25,
                        lineStyle: {
                            width: 2,
                            color: 'auto'
                        }
                    },
                    axisLabel: {
                        distance: -20,
                        color: '#666',
                        rotate: 'tangential',
                        fontSize: 12
                    }
                }
            ]
        };
    }
    disconnectedCallback() {
        super.disconnectedCallback();
        if (this.resizeObserver) {
            this.resizeObserver.disconnect();
        }
    }
    update(changedProperties) {
        changedProperties.forEach((oldValue, propName) => {
            if (propName === 'inputData' && this.gaugeContainer) {
                this.transformData();
                this.adjustSizes();
            }
        });
        super.update(changedProperties);
    }
    firstUpdated(_changedProperties) {
        var _a, _b;
        this.resizeObserver.observe((_a = this.shadowRoot) === null || _a === void 0 ? void 0 : _a.querySelector('.wrapper'));
        this.gaugeContainer = (_b = this.shadowRoot) === null || _b === void 0 ? void 0 : _b.querySelector('.gauge-container');
        this.sizingSetup();
        this.transformData();
        this.adjustSizes();
    }
    sizingSetup() {
        var _a, _b, _c, _d, _e;
        if (this.origWidth !== 0 && this.origHeight !== 0)
            return;
        this.boxes = Array.from((_a = this === null || this === void 0 ? void 0 : this.shadowRoot) === null || _a === void 0 ? void 0 : _a.querySelectorAll('.chart'));
        if (!this.boxes.length)
            return;
        this.origWidth =
            (_c = (_b = this.boxes) === null || _b === void 0 ? void 0 : _b.map((b) => b.getBoundingClientRect().width).reduce((p, c) => (c > p ? c : p), 0)) !== null && _c !== void 0 ? _c : 0;
        this.origHeight =
            (_e = (_d = this.boxes) === null || _d === void 0 ? void 0 : _d.map((b) => b.getBoundingClientRect().height).reduce((p, c) => (c > p ? c : p), 0)) !== null && _e !== void 0 ? _e : 0;
    }
    adjustSizes() {
        var _a, _b, _c;
        // if (!this.origHeight) return
        if (!this.gaugeContainer)
            return;
        const userWidth = this.gaugeContainer.getBoundingClientRect().width;
        const userHeight = this.gaugeContainer.getBoundingClientRect().height;
        const count = this.dataSets.length;
        const width = this.origWidth;
        const height = this.origHeight;
        if (!userHeight || !userWidth || !width || !height)
            return;
        const fits = [];
        for (let c = 1; c <= count; c++) {
            const r = Math.ceil(count / c);
            const uwgap = userWidth - 12 * (c - 1);
            const uhgap = userHeight - 12 * (r - 1);
            const m = uwgap / width / c;
            const size = m * m * width * height * count;
            if (r * m * height <= uhgap)
                fits.push({ c, r, m, size, uwgap, uhgap });
        }
        for (let r = 1; r <= count; r++) {
            const c = Math.ceil(count / r);
            const uwgap = userWidth - 12 * (c - 1);
            const uhgap = userHeight - 12 * (r - 1);
            const m = uhgap / height / r;
            const size = m * m * width * height * count;
            if (c * m * width <= uwgap)
                fits.push({ c, r, m, size, uwgap, uhgap });
        }
        const maxSize = fits.reduce((p, c) => (c.size < p ? p : c.size), 0);
        const fit = fits.find((f) => f.size === maxSize);
        const modifier = (_a = fit === null || fit === void 0 ? void 0 : fit.m) !== null && _a !== void 0 ? _a : 0;
        // console.log(
        //     'FITS count',
        //     userWidth,
        //     count,
        //     fit,
        //     fits,
        //     'new size',
        //     fit?.size.toFixed(0),
        //     'total space',
        //     (userWidth * userHeight).toFixed(0),
        //     this.boxes
        // )
        this.boxes = Array.from((_b = this === null || this === void 0 ? void 0 : this.shadowRoot) === null || _b === void 0 ? void 0 : _b.querySelectorAll('.chart'));
        (_c = this.boxes) === null || _c === void 0 ? void 0 : _c.forEach((box) => box.setAttribute('style', `width:${modifier * width}px; height:${modifier * height}px`));
        this.modifier = modifier;
        for (const canvas in this.canvasList) {
            this.canvasList[canvas].resize();
        }
        this.applyData();
    }
    async transformData() {
        var _a;
        if (!(this === null || this === void 0 ? void 0 : this.inputData))
            return;
        this.dataSets = [];
        (_a = this.inputData.dataseries) === null || _a === void 0 ? void 0 : _a.forEach((ds) => {
            var _a;
            // pivot data
            const distincts = [...new Set((_a = ds === null || ds === void 0 ? void 0 : ds.data) === null || _a === void 0 ? void 0 : _a.map((d) => d.pivot))];
            distincts.forEach((piv) => {
                var _a, _b;
                const prefix = piv ? `${piv} - ` : '';
                const pds = {
                    label: prefix + `${(_a = ds.label) !== null && _a !== void 0 ? _a : ''}`,
                    unit: ds.unit,
                    advanced: ds.advanced,
                    valueColor: ds.valueColor,
                    sections: ds.sections,
                    data: distincts.length === 1 ? ds.data : (_b = ds === null || ds === void 0 ? void 0 : ds.data) === null || _b === void 0 ? void 0 : _b.filter((d) => d.pivot === piv)
                };
                this.dataSets.push(pds);
            });
        });
        this.setupCharts();
    }
    applyData() {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26;
        const modifier = this.modifier;
        this.dataSets.forEach((d) => {
            var _a;
            (_a = d.label) !== null && _a !== void 0 ? _a : (d.label = '');
        });
        this.dataSets.sort((a, b) => (a.label > b.label ? 1 : -1));
        this.requestUpdate();
        for (const ds of this.dataSets) {
            // compute derivative values
            // filter latest values and calculate average
            (_a = ds.advanced) !== null && _a !== void 0 ? _a : (ds.advanced = {});
            if (typeof ((_b = ds.advanced) === null || _b === void 0 ? void 0 : _b.averageLatest) !== 'number' || isNaN((_c = ds.advanced) === null || _c === void 0 ? void 0 : _c.averageLatest))
                ds.advanced.averageLatest = 1;
            const data = (_f = (_d = ds === null || ds === void 0 ? void 0 : ds.data) === null || _d === void 0 ? void 0 : _d.slice(-((_e = ds.advanced) === null || _e === void 0 ? void 0 : _e.averageLatest) || -1)) !== null && _f !== void 0 ? _f : [];
            const values = ((_h = (_g = data === null || data === void 0 ? void 0 : data.map((d) => d.value)) === null || _g === void 0 ? void 0 : _g.filter((p) => p !== undefined)) !== null && _h !== void 0 ? _h : []);
            const average = values.reduce((p, c) => p + c, 0) / values.length;
            ds.needleValue = isNaN(average) ? (_k = (_j = ds.sections) === null || _j === void 0 ? void 0 : _j.sectionLimits) === null || _k === void 0 ? void 0 : _k[0] : average;
            ds.range =
                ((_q = (_m = (_l = ds.sections) === null || _l === void 0 ? void 0 : _l.sectionLimits) === null || _m === void 0 ? void 0 : _m[((_p = (_o = ds.sections) === null || _o === void 0 ? void 0 : _o.sectionLimits) === null || _p === void 0 ? void 0 : _p.length) - 1]) !== null && _q !== void 0 ? _q : 100) -
                    ((_t = (_s = (_r = ds.sections) === null || _r === void 0 ? void 0 : _r.sectionLimits) === null || _s === void 0 ? void 0 : _s[0]) !== null && _t !== void 0 ? _t : 0);
            if (isNaN(ds.range))
                ds.range = 100;
            ds.ranges = (_w = (_v = (_u = ds.sections) === null || _u === void 0 ? void 0 : _u.sectionLimits) === null || _v === void 0 ? void 0 : _v.map((v, i, a) => { var _a; return v - ((_a = a === null || a === void 0 ? void 0 : a[i - 1]) !== null && _a !== void 0 ? _a : 0); }).slice(1)) !== null && _w !== void 0 ? _w : [];
            // const option = this.canvasList[ds.label].getOption()
            const option = structuredClone(this.template);
            const ga = option.series[0], ga2 = option.series[1];
            // Title
            option.title.text = ds.label;
            option.title.textStyle.fontSize = 32 * modifier;
            // Needle
            // Check age of data Latency
            const tsp = Date.parse((_z = (_y = (_x = ds === null || ds === void 0 ? void 0 : ds.data) === null || _x === void 0 ? void 0 : _x[0]) === null || _y === void 0 ? void 0 : _y.tsp) !== null && _z !== void 0 ? _z : '');
            if (isNaN(tsp)) {
                const now = new Date().getTime();
                if (now - tsp > ((_1 = (_0 = ds.advanced) === null || _0 === void 0 ? void 0 : _0.maxLatency) !== null && _1 !== void 0 ? _1 : Infinity) * 1000)
                    ds.needleValue = undefined;
            }
            ga.data[0].value = ds.needleValue;
            ga.data[0].name = ds.unit;
            ga.title.fontSize = 32 * modifier;
            ga.title.color = (_2 = ds.valueColor) !== null && _2 !== void 0 ? _2 : 'black';
            ga.detail.color = (_3 = ds.valueColor) !== null && _3 !== void 0 ? _3 : 'black';
            ga.detail.fontSize = 60 * modifier;
            ga.detail.formatter = (val) => (isNaN(val) ? '-' : val.toFixed(0));
            // ga.anchor.itemStyle.color = ds.valueColor
            // ga.pointer.itemStyle.color = ds.valueColor
            // Axis
            ga2.min = ((_5 = (_4 = ds.sections) === null || _4 === void 0 ? void 0 : _4.sectionLimits) === null || _5 === void 0 ? void 0 : _5.length) ? Math.min(...(_6 = ds.sections) === null || _6 === void 0 ? void 0 : _6.sectionLimits) : 0;
            ga2.max = ((_8 = (_7 = ds.sections) === null || _7 === void 0 ? void 0 : _7.sectionLimits) === null || _8 === void 0 ? void 0 : _8.length) ? Math.max(...(_9 = ds.sections) === null || _9 === void 0 ? void 0 : _9.sectionLimits) : 100;
            ga.min = ga2.min;
            ga.max = ga2.max;
            const colorSections = (_11 = (_10 = ds.sections) === null || _10 === void 0 ? void 0 : _10.backgroundColors) === null || _11 === void 0 ? void 0 : _11.map((b, i) => {
                var _a, _b, _c;
                return [
                    (((_c = (_b = (_a = ds.sections) === null || _a === void 0 ? void 0 : _a.sectionLimits) === null || _b === void 0 ? void 0 : _b[i + 1]) !== null && _c !== void 0 ? _c : ga.min) - ga.min) / ds.range,
                    b
                ];
            }).filter(([s]) => !isNaN(s));
            ga2.axisLine.lineStyle.width = 8 * modifier;
            ga2.axisLine.lineStyle.color = (colorSections === null || colorSections === void 0 ? void 0 : colorSections.length)
                ? colorSections
                : ga2.axisLine.lineStyle.color;
            ga2.axisLabel.fontSize = 20 * modifier;
            // ga2.axisLabel.color = ds.valueColor
            ga2.axisLabel.distance = -24 * modifier;
            ga2.splitLine.length = 16 * modifier;
            ga2.splitLine.distance = -16 * modifier;
            // Progress
            let progressColor = (_15 = (_13 = (_12 = ds.sections) === null || _12 === void 0 ? void 0 : _12.backgroundColors) === null || _13 === void 0 ? void 0 : _13[((_14 = ds.sections) === null || _14 === void 0 ? void 0 : _14.backgroundColors.length) - 1]) !== null && _15 !== void 0 ? _15 : 'green';
            for (const [i, s] of (_18 = (_17 = (_16 = ds.sections) === null || _16 === void 0 ? void 0 : _16.sectionLimits) === null || _17 === void 0 ? void 0 : _17.entries()) !== null && _18 !== void 0 ? _18 : []) {
                if (s > ds.needleValue) {
                    progressColor =
                        (_24 = (_21 = (_20 = (_19 = ds.sections) === null || _19 === void 0 ? void 0 : _19.backgroundColors) === null || _20 === void 0 ? void 0 : _20[i - 1]) !== null && _21 !== void 0 ? _21 : (_23 = (_22 = ds.sections) === null || _22 === void 0 ? void 0 : _22.backgroundColors) === null || _23 === void 0 ? void 0 : _23[0]) !== null && _24 !== void 0 ? _24 : 'green';
                    break;
                }
            }
            ga.progress.itemStyle.color = progressColor;
            ga.progress.width = 80 * modifier;
            // Apply
            (_26 = this.canvasList[(_25 = ds.label) !== null && _25 !== void 0 ? _25 : '']) === null || _26 === void 0 ? void 0 : _26.setOption(option);
        }
    }
    setupCharts() {
        var _a;
        // remove the gauge canvases of non provided data series
        for (const label in this.canvasList) {
            const ex = this.dataSets.find((ds) => ds.label === label);
            if (!ex) {
                delete this.canvasList[label];
                const containerDiv = (_a = this.gaugeContainer) === null || _a === void 0 ? void 0 : _a.querySelector(`[name="${label}"]`);
                containerDiv === null || containerDiv === void 0 ? void 0 : containerDiv.remove();
            }
        }
        this.dataSets.forEach((ds) => {
            var _a, _b, _c, _d;
            if (this.canvasList[(_a = ds.label) !== null && _a !== void 0 ? _a : ''])
                return;
            const newCanvas = document.createElement('div');
            newCanvas.setAttribute('name', (_b = ds.label) !== null && _b !== void 0 ? _b : '');
            newCanvas.setAttribute('class', 'chart');
            newCanvas.setAttribute('style', `min-width: 600px; min-height: 400px; width: 600px; height: 400px;`);
            this.gaugeContainer.appendChild(newCanvas);
            // @ts-ignore
            this.canvasList[(_c = ds.label) !== null && _c !== void 0 ? _c : ''] = echarts.init(newCanvas);
            this.canvasList[(_d = ds.label) !== null && _d !== void 0 ? _d : ''].setOption(structuredClone(this.template));
        });
        this.sizingSetup();
    }
    render() {
        var _a, _b, _c, _d, _e, _f;
        return ke `
            <div class="wrapper">
                <header class="paging" ?active=${((_a = this.inputData) === null || _a === void 0 ? void 0 : _a.title) || ((_b = this.inputData) === null || _b === void 0 ? void 0 : _b.subTitle)}>
                    <h3 class="paging" ?active=${(_c = this.inputData) === null || _c === void 0 ? void 0 : _c.title}>${(_d = this.inputData) === null || _d === void 0 ? void 0 : _d.title}</h3>
                    <p class="paging" ?active=${(_e = this.inputData) === null || _e === void 0 ? void 0 : _e.subTitle}>${(_f = this.inputData) === null || _f === void 0 ? void 0 : _f.subTitle}</p>
                </header>
                <div class="paging no-data" ?active=${!this.dataSets.length}>No Data</div>
                <div class="gauge-container"></div>
            </div>
        `;
    }
}
WidgetGauge.styles = i$1 `
        :host {
            display: block;
            color: var(--re-text-color, #000);
            font-family: sans-serif;
            box-sizing: border-box;
            position: relative;
            margin: auto;
        }

        .paging:not([active]) {
            display: none !important;
        }

        .wrapper {
            display: flex;
            flex-direction: column;
            height: 100%;
            width: 100%;
            padding: 16px;
            box-sizing: border-box;
        }
        .gauge-container {
            display: flex;
            flex: 1;
            justify-content: center;
            align-items: center;
            flex-wrap: wrap;
            overflow: hidden;
            position: relative;
            gap: 12px;
        }

        header {
            display: flex;
            flex-direction: column;
            margin: 0 0 16px 0;
        }
        h3 {
            margin: 0;
            max-width: 300px;
            overflow: hidden;
            text-overflow: ellipsis;
            white-space: nowrap;
            color: var(--re-text-color, #000) !important;
        }
        p {
            margin: 10px 0 0 0;
            max-width: 300px;
            font-size: 14px;
            line-height: 17px;
            overflow: hidden;
            text-overflow: ellipsis;
            white-space: nowrap;
            color: var(--re-text-color, #000) !important;
        }

        .chart {
            width: 600px; /* will be overriden by adjustSizes */
            height: 400px;
        }

        .no-data {
            font-size: 20px;
            color: var(--re-text-color, #000);
            display: flex;
            height: 100%;
            width: 100%;
            text-align: center;
            align-items: center;
            justify-content: center;
        }
    `;
__decorate([
    n({ type: Object })
], WidgetGauge.prototype, "inputData", void 0);
__decorate([
    r()
], WidgetGauge.prototype, "dataSets", void 0);
__decorate([
    r()
], WidgetGauge.prototype, "canvasList", void 0);
window.customElements.define('widget-gauge-1.6.10', WidgetGauge);

export { WidgetGauge };
//# sourceMappingURL=widget-gauge.js.map
